<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ReportData StructType
 * @subpackage Structs
 */
class ReportData extends AbstractStructBase
{
    /**
     * The overallImpressionCount
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - nillable: true
     * @var int
     */
    public $overallImpressionCount;
    /**
     * The uniqueImpressionCount
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - nillable: true
     * @var int
     */
    public $uniqueImpressionCount;
    /**
     * The impressionCommission
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - nillable: true
     * @var float
     */
    public $impressionCommission;
    /**
     * The overallClickCount
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - nillable: true
     * @var int
     */
    public $overallClickCount;
    /**
     * The uniqueClickCount
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - nillable: true
     * @var int
     */
    public $uniqueClickCount;
    /**
     * The clickCommission
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - nillable: true
     * @var float
     */
    public $clickCommission;
    /**
     * The leadCount
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - nillable: true
     * @var int
     */
    public $leadCount;
    /**
     * The leadCommission
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - nillable: true
     * @var float
     */
    public $leadCommission;
    /**
     * The saleCount
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - nillable: true
     * @var int
     */
    public $saleCount;
    /**
     * The saleCommission
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - nillable: true
     * @var float
     */
    public $saleCommission;
    /**
     * The fixedCommission
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - nillable: true
     * @var float
     */
    public $fixedCommission;
    /**
     * The CTR
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - nillable: true
     * @var float
     */
    public $CTR;
    /**
     * The CLR
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - nillable: true
     * @var float
     */
    public $CLR;
    /**
     * The CSR
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - nillable: true
     * @var float
     */
    public $CSR;
    /**
     * The eCPM
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - nillable: true
     * @var float
     */
    public $eCPM;
    /**
     * The EPC
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - nillable: true
     * @var float
     */
    public $EPC;
    /**
     * The totalCommission
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - nillable: true
     * @var float
     */
    public $totalCommission;
    /**
     * Constructor method for ReportData
     * @uses ReportData::setOverallImpressionCount()
     * @uses ReportData::setUniqueImpressionCount()
     * @uses ReportData::setImpressionCommission()
     * @uses ReportData::setOverallClickCount()
     * @uses ReportData::setUniqueClickCount()
     * @uses ReportData::setClickCommission()
     * @uses ReportData::setLeadCount()
     * @uses ReportData::setLeadCommission()
     * @uses ReportData::setSaleCount()
     * @uses ReportData::setSaleCommission()
     * @uses ReportData::setFixedCommission()
     * @uses ReportData::setCTR()
     * @uses ReportData::setCLR()
     * @uses ReportData::setCSR()
     * @uses ReportData::setECPM()
     * @uses ReportData::setEPC()
     * @uses ReportData::setTotalCommission()
     * @param int $overallImpressionCount
     * @param int $uniqueImpressionCount
     * @param float $impressionCommission
     * @param int $overallClickCount
     * @param int $uniqueClickCount
     * @param float $clickCommission
     * @param int $leadCount
     * @param float $leadCommission
     * @param int $saleCount
     * @param float $saleCommission
     * @param float $fixedCommission
     * @param float $cTR
     * @param float $cLR
     * @param float $cSR
     * @param float $eCPM
     * @param float $ePC
     * @param float $totalCommission
     */
    public function __construct($overallImpressionCount = null, $uniqueImpressionCount = null, $impressionCommission = null, $overallClickCount = null, $uniqueClickCount = null, $clickCommission = null, $leadCount = null, $leadCommission = null, $saleCount = null, $saleCommission = null, $fixedCommission = null, $cTR = null, $cLR = null, $cSR = null, $eCPM = null, $ePC = null, $totalCommission = null)
    {
        $this
            ->setOverallImpressionCount($overallImpressionCount)
            ->setUniqueImpressionCount($uniqueImpressionCount)
            ->setImpressionCommission($impressionCommission)
            ->setOverallClickCount($overallClickCount)
            ->setUniqueClickCount($uniqueClickCount)
            ->setClickCommission($clickCommission)
            ->setLeadCount($leadCount)
            ->setLeadCommission($leadCommission)
            ->setSaleCount($saleCount)
            ->setSaleCommission($saleCommission)
            ->setFixedCommission($fixedCommission)
            ->setCTR($cTR)
            ->setCLR($cLR)
            ->setCSR($cSR)
            ->setECPM($eCPM)
            ->setEPC($ePC)
            ->setTotalCommission($totalCommission);
    }
    /**
     * Get overallImpressionCount value
     * @return int|null
     */
    public function getOverallImpressionCount()
    {
        return $this->overallImpressionCount;
    }
    /**
     * Set overallImpressionCount value
     * @param int $overallImpressionCount
     * @return \StructType\ReportData
     */
    public function setOverallImpressionCount($overallImpressionCount = null)
    {
        // validation for constraint: int
        if (!is_null($overallImpressionCount) && !is_numeric($overallImpressionCount)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($overallImpressionCount)), __LINE__);
        }
        $this->overallImpressionCount = $overallImpressionCount;
        return $this;
    }
    /**
     * Get uniqueImpressionCount value
     * @return int|null
     */
    public function getUniqueImpressionCount()
    {
        return $this->uniqueImpressionCount;
    }
    /**
     * Set uniqueImpressionCount value
     * @param int $uniqueImpressionCount
     * @return \StructType\ReportData
     */
    public function setUniqueImpressionCount($uniqueImpressionCount = null)
    {
        // validation for constraint: int
        if (!is_null($uniqueImpressionCount) && !is_numeric($uniqueImpressionCount)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($uniqueImpressionCount)), __LINE__);
        }
        $this->uniqueImpressionCount = $uniqueImpressionCount;
        return $this;
    }
    /**
     * Get impressionCommission value
     * @return float|null
     */
    public function getImpressionCommission()
    {
        return $this->impressionCommission;
    }
    /**
     * Set impressionCommission value
     * @param float $impressionCommission
     * @return \StructType\ReportData
     */
    public function setImpressionCommission($impressionCommission = null)
    {
        $this->impressionCommission = $impressionCommission;
        return $this;
    }
    /**
     * Get overallClickCount value
     * @return int|null
     */
    public function getOverallClickCount()
    {
        return $this->overallClickCount;
    }
    /**
     * Set overallClickCount value
     * @param int $overallClickCount
     * @return \StructType\ReportData
     */
    public function setOverallClickCount($overallClickCount = null)
    {
        // validation for constraint: int
        if (!is_null($overallClickCount) && !is_numeric($overallClickCount)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($overallClickCount)), __LINE__);
        }
        $this->overallClickCount = $overallClickCount;
        return $this;
    }
    /**
     * Get uniqueClickCount value
     * @return int|null
     */
    public function getUniqueClickCount()
    {
        return $this->uniqueClickCount;
    }
    /**
     * Set uniqueClickCount value
     * @param int $uniqueClickCount
     * @return \StructType\ReportData
     */
    public function setUniqueClickCount($uniqueClickCount = null)
    {
        // validation for constraint: int
        if (!is_null($uniqueClickCount) && !is_numeric($uniqueClickCount)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($uniqueClickCount)), __LINE__);
        }
        $this->uniqueClickCount = $uniqueClickCount;
        return $this;
    }
    /**
     * Get clickCommission value
     * @return float|null
     */
    public function getClickCommission()
    {
        return $this->clickCommission;
    }
    /**
     * Set clickCommission value
     * @param float $clickCommission
     * @return \StructType\ReportData
     */
    public function setClickCommission($clickCommission = null)
    {
        $this->clickCommission = $clickCommission;
        return $this;
    }
    /**
     * Get leadCount value
     * @return int|null
     */
    public function getLeadCount()
    {
        return $this->leadCount;
    }
    /**
     * Set leadCount value
     * @param int $leadCount
     * @return \StructType\ReportData
     */
    public function setLeadCount($leadCount = null)
    {
        // validation for constraint: int
        if (!is_null($leadCount) && !is_numeric($leadCount)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($leadCount)), __LINE__);
        }
        $this->leadCount = $leadCount;
        return $this;
    }
    /**
     * Get leadCommission value
     * @return float|null
     */
    public function getLeadCommission()
    {
        return $this->leadCommission;
    }
    /**
     * Set leadCommission value
     * @param float $leadCommission
     * @return \StructType\ReportData
     */
    public function setLeadCommission($leadCommission = null)
    {
        $this->leadCommission = $leadCommission;
        return $this;
    }
    /**
     * Get saleCount value
     * @return int|null
     */
    public function getSaleCount()
    {
        return $this->saleCount;
    }
    /**
     * Set saleCount value
     * @param int $saleCount
     * @return \StructType\ReportData
     */
    public function setSaleCount($saleCount = null)
    {
        // validation for constraint: int
        if (!is_null($saleCount) && !is_numeric($saleCount)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($saleCount)), __LINE__);
        }
        $this->saleCount = $saleCount;
        return $this;
    }
    /**
     * Get saleCommission value
     * @return float|null
     */
    public function getSaleCommission()
    {
        return $this->saleCommission;
    }
    /**
     * Set saleCommission value
     * @param float $saleCommission
     * @return \StructType\ReportData
     */
    public function setSaleCommission($saleCommission = null)
    {
        $this->saleCommission = $saleCommission;
        return $this;
    }
    /**
     * Get fixedCommission value
     * @return float|null
     */
    public function getFixedCommission()
    {
        return $this->fixedCommission;
    }
    /**
     * Set fixedCommission value
     * @param float $fixedCommission
     * @return \StructType\ReportData
     */
    public function setFixedCommission($fixedCommission = null)
    {
        $this->fixedCommission = $fixedCommission;
        return $this;
    }
    /**
     * Get CTR value
     * @return float|null
     */
    public function getCTR()
    {
        return $this->CTR;
    }
    /**
     * Set CTR value
     * @param float $cTR
     * @return \StructType\ReportData
     */
    public function setCTR($cTR = null)
    {
        $this->CTR = $cTR;
        return $this;
    }
    /**
     * Get CLR value
     * @return float|null
     */
    public function getCLR()
    {
        return $this->CLR;
    }
    /**
     * Set CLR value
     * @param float $cLR
     * @return \StructType\ReportData
     */
    public function setCLR($cLR = null)
    {
        $this->CLR = $cLR;
        return $this;
    }
    /**
     * Get CSR value
     * @return float|null
     */
    public function getCSR()
    {
        return $this->CSR;
    }
    /**
     * Set CSR value
     * @param float $cSR
     * @return \StructType\ReportData
     */
    public function setCSR($cSR = null)
    {
        $this->CSR = $cSR;
        return $this;
    }
    /**
     * Get eCPM value
     * @return float|null
     */
    public function getECPM()
    {
        return $this->eCPM;
    }
    /**
     * Set eCPM value
     * @param float $eCPM
     * @return \StructType\ReportData
     */
    public function setECPM($eCPM = null)
    {
        $this->eCPM = $eCPM;
        return $this;
    }
    /**
     * Get EPC value
     * @return float|null
     */
    public function getEPC()
    {
        return $this->EPC;
    }
    /**
     * Set EPC value
     * @param float $ePC
     * @return \StructType\ReportData
     */
    public function setEPC($ePC = null)
    {
        $this->EPC = $ePC;
        return $this;
    }
    /**
     * Get totalCommission value
     * @return float|null
     */
    public function getTotalCommission()
    {
        return $this->totalCommission;
    }
    /**
     * Set totalCommission value
     * @param float $totalCommission
     * @return \StructType\ReportData
     */
    public function setTotalCommission($totalCommission = null)
    {
        $this->totalCommission = $totalCommission;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ReportData
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
